//knight HUD

#include "/Entities/Common/GUI/ActorHUDStartPos.as";
#include "KnightCommon.as";

const string iconsFilename = "Entities/Characters/Knight/KnightIcons.png";
const int slotsSize = 5;

void onInit( CSprite@ this )
{
	this.getCurrentScript().runFlags |= Script::tick_myplayer;
	this.getCurrentScript().removeIfTag = "dead";
	this.getBlob().set_u8("gui_HUD_slots_width", slotsSize);
}
	   
void ManageCursors( CBlob@ this )
{
	CHUD@ hud = getHUD();
	if (hud.hasButtons()) {
		hud.SetDefaultCursor();
	}
	else
	{		 	
		if (this.isAttached() && this.isAttachedToPoint("GUNNER")) {
			hud.SetCursorImage("Entities/Characters/Archer/ArcherCursor.png", Vec2f(32,32));
			hud.SetCursorOffset( Vec2f(-32, -32) );
		}
		else {
			hud.SetCursorImage("Entities/Characters/Knight/KnightCursor.png", Vec2f(32,32));

			KnightInfo@ knight;
			if (!this.get( "knightInfo", @knight )) {
				return;
			}

			int frame = (knight.state == KnightStates::sword_drawn && knight.swordTimer > 6) ?
				Maths::Min((knight.swordTimer)*8/(KnightVars::slash_charge_level2), 8) : 0;
			
			frame == 0 ? hud.SetCursorOffset( Vec2f(0, 0) ) : hud.SetCursorOffset( Vec2f(-32+12, -32+12) );
			hud.SetCursorFrame(frame);
		}
	}
}

void onRender( CSprite@ this )
{
	if (g_videorecording)
		return;

	CBlob@ blob = this.getBlob();
	CPlayer@ player = blob.getPlayer();

	ManageCursors( blob );

	// draw inventory

	Vec2f tl = getActorHUDStartPosition(blob, slotsSize);
	DrawInventoryOnHUD( blob, tl );	  

	u8 bombType = blob.get_u8("bomb type");
	u8 frame = 1;
	if (bombType == 0){
		frame = 0;
	}
	else if (bombType < 255) {
		frame = 1 + bombType;
	}

	// draw coins

	const int coins = player !is null ? player.getCoins() : 0;
	DrawCoinsOnHUD( blob, coins, tl, slotsSize-2 );

	// draw class icon

	GUI::DrawIcon( iconsFilename, frame, Vec2f(16,32), tl+Vec2f(8 + (slotsSize-1)*32,-16), 1.0f);
}

